package meerkat.voting.controller.callbacks;

import com.google.common.util.concurrent.FutureCallback;
import meerkat.voting.controller.commands.ControllerCommand;

import java.util.concurrent.LinkedBlockingQueue;

public abstract class ControllerCallback implements FutureCallback {
    private final int requestIdentifier;
    private final long ballotSerialNumber;
    protected LinkedBlockingQueue<ControllerCommand> controllerQueue;

    protected ControllerCallback (int requestId,
                                  long ballotSerialNumber,
                                  LinkedBlockingQueue<ControllerCommand> controllerQueue) {
        this.requestIdentifier = requestId;
        this.ballotSerialNumber = ballotSerialNumber;
        this.controllerQueue = controllerQueue;
    }

    protected int getRequestIdentifier () {
        return requestIdentifier;
    }
    protected long getBallotSerialNumber () {
        return ballotSerialNumber;
    }
}
