package meerkat.voting.controller.callbacks;

import meerkat.voting.controller.commands.ControllerCommand;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.concurrent.LinkedBlockingQueue;

/**
 * Created by hai on 21/04/16.
 */
public class HaltCallback extends ControllerCallback{
    protected final static Logger logger = LoggerFactory.getLogger(HaltCallback.class);

    public HaltCallback(int requestId,
                        long ballotSerialNumber,
                        LinkedBlockingQueue<ControllerCommand> controllerQueue) {
        super(requestId, ballotSerialNumber, controllerQueue);
    }


    @Override
    public void onSuccess(Object result) {
        throw new UnsupportedOperationException("HaltCallback: onSuccess: There cannot be a successful return for this task. Returned value is " + result);
    }

    @Override
    public void onFailure(Throwable t) {
        logger.error("Halting initiated a failure: " + t);
    }

}
