package meerkat.voting.controller.callbacks;

import meerkat.voting.controller.commands.ChannelChoiceCommand;
import meerkat.voting.controller.commands.ControllerCommand;
import meerkat.voting.controller.commands.RestartVotingCommand;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.concurrent.LinkedBlockingQueue;

public class NewVoterCallback extends ControllerCallback {
    protected final static Logger logger = LoggerFactory.getLogger(NewVoterCallback.class);

    public NewVoterCallback(int requestId,
                            long ballotSerialNumber,
                            LinkedBlockingQueue<ControllerCommand> controllerQueue) {
        super(requestId, ballotSerialNumber, controllerQueue);
    }

    @Override
    public void onSuccess(Object v) {
        logger.debug("callback for new voting returned success");
        assert v==null;
        controllerQueue.add(new ChannelChoiceCommand(getRequestIdentifier(), getBallotSerialNumber()));
    }

    @Override
    public void onFailure(Throwable t) {
        logger.error("New voting session got a failure: " + t);
        controllerQueue.add(new RestartVotingCommand(getRequestIdentifier(), getBallotSerialNumber()));
    }
}
