package meerkat.voting.controller.callbacks;

import meerkat.voting.controller.commands.ControllerCommand;
import meerkat.voting.controller.commands.RestartVotingCommand;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.concurrent.LinkedBlockingQueue;

public class OutputDeviceCallback extends ControllerCallback {
    protected final static Logger logger = LoggerFactory.getLogger(OutputDeviceCallback.class);

    public OutputDeviceCallback(int requestId,
                                long ballotSerialNumber,
                                LinkedBlockingQueue<ControllerCommand> controllerQueue) {
        super(requestId, ballotSerialNumber, controllerQueue);
    }

    @Override
    public void onSuccess(Object v) {
        assert v instanceof Void;
    }

    @Override
    public void onFailure(Throwable t) {
        logger.error("WaitForFinishCallback got a failure: " + t);
        controllerQueue.add(new RestartVotingCommand(getRequestIdentifier(), getBallotSerialNumber()));
    }
}
