package meerkat.voting.controller.selector;

import java.util.HashMap;
import java.lang.Math;

/**
 * Created by hai on 02/05/16.
 */
public class SimpleCategoriesData {

    private int[] sharedDefaults;
    private HashMap<SingleChosenAnswer, int[]> questionsSelections;
    private int maxQuestionNumber;

    public SimpleCategoriesData() {
        sharedDefaults = new int[0];
        questionsSelections = new HashMap();
        maxQuestionNumber = -1;
    }

    public void setSharedDefaults(int[] sharedDefaultsIndices) {
        this.sharedDefaults = sharedDefaultsIndices;
        maxQuestionNumber = Math.max(maxQuestionNumber, maxInt(sharedDefaultsIndices));
    }

    public int[] getSharedDefaults() {
        return sharedDefaults;
    }

    public void setItem(SingleChosenAnswer key, int[] questionIndices) {
        questionsSelections.put(key, questionIndices);
        maxQuestionNumber = Math.max(maxQuestionNumber, maxInt(questionIndices));
    }

    public int[] getItem(SingleChosenAnswer key) {
        return questionsSelections.get(key);
    }

    public int getMaxQuestionNumber() {
        return maxQuestionNumber;
    }


    private static int maxInt(int[] arr) {
        int m = -1;
        for (int i: arr) {
            m = Math.max(i , m);
        }
        return m;
    }

    public String toString () {
        String s = "SimpleCategoriesData:\n";
        s += "shared : " + arrayToString(sharedDefaults) + "\n";
        s += "map : \n";
        for (SingleChosenAnswer key : questionsSelections.keySet()) {
            s += key + " : " + arrayToString(questionsSelections.get(key)) + "\n";
        }
        return s;
    }

    private String arrayToString (int[] a) {
        if (a.length == 0) {
            return "[]";
        }
        String s = "[" + a[0];
        for (int i = 1; i < a.length; ++i) {
            s += ", " + a[i];
        }
        return s + "]";
    }

}
